diff -2rcN /usr/goinfre/gcc-2.7.0/config/m68k/t-amigados gcc-2.7.0-amiga/config/m68k/t-amigados
*** /usr/goinfre/gcc-2.7.0/config/m68k/t-amigados
--- gcc-2.7.0-amiga/config/m68k/t-amigados	Fri Jun 23 11:52:21 1995
***************
*** 0 ****
--- 1,352 ----
+ # Makefile fragment for amigados target.
+ 
+ # We generate two additional things:
+ #
+ # libb/libgcc.a
+ #	A base relative version of libgcc.a which is used when compiling and
+ #	linking with the '-resident' option.
+ #
+ # libb/libm020/libgcc.a
+ #	An accelerated base relative version of libgcc.a which is used when
+ #	compiling and linking with the '-mc68020' & '-resident' options.
+ #
+ # libm020/libgcc.a
+ #	An accelerated version of libgcc.a which is used when compiling and
+ #	linking with the '-mc68020' option.
+ #
+ # xgccv
+ #	A forking gcc instead of one calling ssytem(). This makes it less
+ #	system conformant (can't ^C it when started from make), while providing
+ #	increased functionality (-pipe option).
+ 
+ # Use the vfork'ing version of gcc by default, so that the -pipe option can
+ # get tested.  To use the regular version just do "make XGCC=gcc".  Note that
+ # PIPE is defined in x-amigados, so if we are doing a native build, it will
+ # be defined.  It can be overridden with "make PIPE=".
+ 
+ XGCC = xgccv $(PIPE)
+ GCC_FOR_TARGET = ./$(XGCC) -B./
+ 
+ # Build residentable versions of the gcc executables by default.  Use
+ # "make RESIDENT=" to build non-residentable versions.
+ # Note:  This failed during bootstrapping of 2.5.5.
+ 
+ #RESIDENT = -resident
+ 
+ # The standard additional target flags for the compiler.
+ 
+ T_CFLAGS = $(RESIDENT)
+ 
+ # Allow the user to override the default target optimizations with gcc, or if
+ # the target compiler is not gcc and doesn't understand -O<N>.
+ 
+ T_OPTIMISE = -O2
+ 
+ # Each compilation environment (Manx, Dice, GCC, SAS/C, etc) provides its
+ # own equivalent of the UNIX /usr/include tree.  For gcc, the standard headers
+ # are in /gnu/include and system specific headers are in /gnu/os-include.
+ # Use these paths for fixincludes.
+ 
+ SYSTEM_HEADER_DIR = /gnu/include
+ OTHER_FIXINCLUDES_DIRS = /gnu/os-include
+ 
+ # We don't need a libgcc1, it's all in ixemul.library
+ 
+ LIBGCC1 = libgcc1.null
+ 
+ # Flags to use when compiling the normal version of libgcc.a.
+ # Don't compile with debugging, as long as there is no debugger.
+ # Explicitly leave out the -resident compilation flag and don't use T_CFLAGS.
+ 
+ LIBGCC2_CFLAGS = $(T_OPTIMIZE) $(INTERNAL_CFLAGS) $(X_CFLAGS) $(CFLAGS) \
+ 		  $(CROSS_GCC_CFLAGS)
+ 
+ # Flags to use when compiling the base relative version of libgcc.a.
+ # Don't compile with debugging, as long as there is no debugger.
+ # Explicitly force -resident in the compilation flags and don't use T_CFLAGS.
+ 
+ LIBBGCC2_CFLAGS = $(T_OPTIMIZE) $(INTERNAL_CFLAGS) $(X_CFLAGS) $(CFLAGS) \
+ 		  $(CROSS_GCC_CFLAGS) -resident
+ 
+ # Flags to use when compiling the 68020 versions of libgcc.a.
+ # Don't compile with debugging, as long as there is no debugger.
+ # Explicitly force -mc68020 in the compilation flags and don't use T_CFLAGS.
+ 
+ LIBM020GCC2_CFLAGS = $(T_OPTIMIZE) $(INTERNAL_CFLAGS) $(X_CFLAGS) $(CFLAGS) \
+ 		  $(CROSS_GCC_CFLAGS) -mc68020
+ 
+ # Flags to use when compiling the base relative 68020 versions of libgcc.a.
+ # Don't compile with debugging, as long as there is no debugger.
+ # Explicitly force -mc68020 & -resident in the compilation flags and don't use
+ # T_CFLAGS.
+ 
+ LIBBM020GCC2_CFLAGS = $(LIBBGCC2_CFLAGS) -mc68020
+ 
+ # Build the base relative library and accelerated libraries.
+ # It is later copied into /gnu/lib/gcc-lib/amigados/<version>/libb/libgcc.a, whereas
+ # libgcc.a is copied into /gnu/lib/gcc-lib/amigados/<version>/libgcc.a.
+ # Accelerated libraries are copied into same directories, with an extra dir level
+ # libm020, thus libb/libm020. It doesn't work very well to define one of the
+ # EXTRA_* macros to contain libb/libgcc.a, particularly for doing "make stageN"
+ # or "make install".
+ 
+ GCC_PARTS=$(GCC_PASSES) libgcc.a libb/libgcc.a libm020/libgcc.a \
+ 		libb/libm020/libgcc.a $(EXTRA_PROGRAMS) $(USE_COLLECT2) $(EXTRA_PARTS)
+ 
+ # Add install_libbgcc to normal define of INSTALL_LIBGCC.  Let install-gccv
+ # hitch a ride on here as well.
+ 
+ INSTALL_LIBGCC = install-libgcc install-libbgcc install-libm020gcc install-libbm020gcc install-gccv
+ 
+ # This includes the knowledge that target amigados doesn't need libgcc1.a
+ 
+ libb/libgcc.a: libgcc1.null libgcc2.c libgcc2.ready $(CONFIG_H) \
+    $(LIB2FUNCS_EXTRA) machmode.h longlong.h gbl-ctors.h config.status
+ # Actually build it in tmplibbgcc.a, then rename at end,
+ # so that libb/libgcc.a itself remains nonexistent if compilation is aborted.
+ 	-rm -f tmplibbgcc.a
+ # -e causes any failing command to make this rule fail.
+ # -e doesn't work in certain shells, so we test $$? as well.
+ 	set -e; \
+ 	for name in $(LIB2FUNCS); \
+ 	do \
+ 	  echo $${name}; \
+ 	  $(GCC_FOR_TARGET) $(LIBBGCC2_CFLAGS) $(INCLUDES) -c -DL$${name} \
+ 	      $(srcdir)/libgcc2.c -o $${name}.o; \
+ 	  if [ $$? -eq 0 ] ; then true; else exit 1; fi; \
+ 	  $(AR) $(AR_FLAGS) tmplibbgcc.a $${name}.o; \
+ 	  rm -f $${name}.o; \
+ 	done
+ # Some shells crash when a loop has no items.
+ # So make sure there is always at least one--`..'.
+ # Then ignore it.
+ # We don't use -e here because there are if statements
+ # that should not make the command give up when the if condition is false.
+ # Instead, we test for failure after each command where it matters.
+ 	-for file in .. $(LIB2FUNCS_EXTRA); \
+ 	do \
+ 	  if [ x$${file} != x.. ]; then \
+ 	    name=`echo $${file} | sed -e 's/[.]c$$//' -e 's/[.]asm$$//'`; \
+ 	    echo $${name}; \
+ 	    if [ $${name}.asm = $${file} ]; then \
+ 	      cp $${file} $${name}.s || exit 1; file=$${name}.s; \
+ 	    else true; fi; \
+ 	    $(GCC_FOR_TARGET) $(LIBBGCC2_CFLAGS) $(INCLUDES) -c $${file}; \
+ 	    if [ $$? -eq 0 ] ; then true; else exit 1; fi; \
+ 	    $(AR) $(AR_FLAGS) tmplibbgcc.a $${name}.o; \
+ 	    rm -f $${name}.[so]; \
+ 	  else true; \
+ 	  fi; \
+ 	done
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) tmplibbgcc.a; else true; fi
+ 	-if [ -d libb ] ; then true ; else mkdir libb ; fi
+ 	mv tmplibbgcc.a libb/libgcc.a
+ 
+ 
+ install-libbgcc: libb/libgcc.a install-dir
+ 	-if [ -d $(libsubdir)/libb ] ; then true ; else mkdir $(libsubdir)/libb ; fi
+ 	-if [ -f libb/libgcc.a ] ; then \
+ 	  rm -f $(libsubdir)/libb/libgcc.a; \
+ 	  $(INSTALL_DATA) libb/libgcc.a $(libsubdir)/libb/libgcc.a; \
+ 	  if $(RANLIB_TEST) ; then \
+ 	    (cd $(libsubdir)/libb; $(RANLIB) libgcc.a); else true; fi; \
+ 	  chmod a-x $(libsubdir)/libb/libgcc.a; \
+ 	else true; fi
+ 
+ libm020/libgcc.a: libgcc1.null libgcc2.c libgcc2.ready $(CONFIG_H) \
+    $(LIB2FUNCS_EXTRA) machmode.h longlong.h gbl-ctors.h config.status
+ # Actually build it in tmplibm020gcc.a, then rename at end,
+ # so that libm020/libgcc.a itself remains nonexistent if compilation is aborted.
+ 	-rm -f tmplibm020gcc.a
+ # -e causes any failing command to make this rule fail.
+ # -e doesn't work in certain shells, so we test $$? as well.
+ 	set -e; \
+ 	for name in $(LIB2FUNCS); \
+ 	do \
+ 	  echo $${name}; \
+ 	  $(GCC_FOR_TARGET) $(LIBM020GCC2_CFLAGS) $(INCLUDES) -c -DL$${name} \
+ 	      $(srcdir)/libgcc2.c -o $${name}.o; \
+ 	  if [ $$? -eq 0 ] ; then true; else exit 1; fi; \
+ 	  $(AR) $(AR_FLAGS) tmplibm020gcc.a $${name}.o; \
+ 	  rm -f $${name}.o; \
+ 	done
+ # Some shells crash when a loop has no items.
+ # So make sure there is always at least one--`..'.
+ # Then ignore it.
+ # We don't use -e here because there are if statements
+ # that should not make the command give up when the if condition is false.
+ # Instead, we test for failure after each command where it matters.
+ 	-for file in .. $(LIB2FUNCS_EXTRA); \
+ 	do \
+ 	  if [ x$${file} != x.. ]; then \
+ 	    name=`echo $${file} | sed -e 's/[.]c$$//' -e 's/[.]asm$$//'`; \
+ 	    echo $${name}; \
+ 	    if [ $${name}.asm = $${file} ]; then \
+ 	      cp $${file} $${name}.s || exit 1; file=$${name}.s; \
+ 	    else true; fi; \
+ 	    $(GCC_FOR_TARGET) $(LIBBGCC2_CFLAGS) $(INCLUDES) -c $${file}; \
+ 	    if [ $$? -eq 0 ] ; then true; else exit 1; fi; \
+ 	    $(AR) $(AR_FLAGS) tmplibm020gcc.a $${name}.o; \
+ 	    rm -f $${name}.[so]; \
+ 	  else true; \
+ 	  fi; \
+ 	done
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) tmplibm020gcc.a; else true; fi
+ 	-if [ -d libm020 ] ; then true ; else mkdir libm020 ; fi
+ 	mv tmplibm020gcc.a libm020/libgcc.a
+ 
+ 
+ install-libm020gcc: libm020/libgcc.a install-dir
+ 	-if [ -d $(libsubdir)/libm020 ] ; then true ; else mkdir $(libsubdir)/libm020 ; fi
+ 	-if [ -f libm020/libgcc.a ] ; then \
+ 	  rm -f $(libsubdir)/libm020/libgcc.a; \
+ 	  $(INSTALL_DATA) libm020/libgcc.a $(libsubdir)/libm020/libgcc.a; \
+ 	  if $(RANLIB_TEST) ; then \
+ 	    (cd $(libsubdir)/libm020; $(RANLIB) libgcc.a); else true; fi; \
+ 	  chmod a-x $(libsubdir)/libm020/libgcc.a; \
+ 	else true; fi
+ 
+ libb/libm020/libgcc.a: libgcc1.null libgcc2.c libgcc2.ready $(CONFIG_H) \
+    $(LIB2FUNCS_EXTRA) machmode.h longlong.h gbl-ctors.h config.status
+ # Actually build it in tmplibbm020gcc.a, then rename at end,
+ # so that libb/libm020/libgcc.a itself remains nonexistent if compilation is aborted.
+ 	-rm -f tmplibbm020gcc.a
+ # -e causes any failing command to make this rule fail.
+ # -e doesn't work in certain shells, so we test $$? as well.
+ 	set -e; \
+ 	for name in $(LIB2FUNCS); \
+ 	do \
+ 	  echo $${name}; \
+ 	  $(GCC_FOR_TARGET) $(LIBBM020GCC2_CFLAGS) $(INCLUDES) -c -DL$${name} \
+ 	      $(srcdir)/libgcc2.c -o $${name}.o; \
+ 	  if [ $$? -eq 0 ] ; then true; else exit 1; fi; \
+ 	  $(AR) $(AR_FLAGS) tmplibbm020gcc.a $${name}.o; \
+ 	  rm -f $${name}.o; \
+ 	done
+ # Some shells crash when a loop has no items.
+ # So make sure there is always at least one--`..'.
+ # Then ignore it.
+ # We don't use -e here because there are if statements
+ # that should not make the command give up when the if condition is false.
+ # Instead, we test for failure after each command where it matters.
+ 	-for file in .. $(LIB2FUNCS_EXTRA); \
+ 	do \
+ 	  if [ x$${file} != x.. ]; then \
+ 	    name=`echo $${file} | sed -e 's/[.]c$$//' -e 's/[.]asm$$//'`; \
+ 	    echo $${name}; \
+ 	    if [ $${name}.asm = $${file} ]; then \
+ 	      cp $${file} $${name}.s || exit 1; file=$${name}.s; \
+ 	    else true; fi; \
+ 	    $(GCC_FOR_TARGET) $(LIBBGCC2CFLAGS) $(INCLUDES) -c $${file}; \
+ 	    if [ $$? -eq 0 ] ; then true; else exit 1; fi; \
+ 	    $(AR) $(AR_FLAGS) tmplibbm020gcc.a $${name}.o; \
+ 	    rm -f $${name}.[so]; \
+ 	  else true; \
+ 	  fi; \
+ 	done
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) tmplibbm020gcc.a; else true; fi
+ 	-if [ -d libb ] ; then true ; else mkdir libb ; fi
+ 	-if [ -d libb/libm020 ] ; then true ; else mkdir libb/libm020 ; fi
+ 	mv tmplibbm020gcc.a libb/libm020/libgcc.a
+ 
+ 
+ install-libbm020gcc: libb/libm020/libgcc.a install-dir
+ 	-if [ -d $(libsubdir)/libb/libm020 ] ; then true ; else mkdir $(libsubdir)/libb/libm020 ; fi
+ 	-if [ -f libb/libm020/libgcc.a ] ; then \
+ 	  rm -f $(libsubdir)/libb/libm020/libgcc.a; \
+ 	  $(INSTALL_DATA) libb/libm020/libgcc.a $(libsubdir)/libb/libm020/libgcc.a; \
+ 	  if $(RANLIB_TEST) ; then \
+ 	    (cd $(libsubdir)/libb/libm020; $(RANLIB) libgcc.a); else true; fi; \
+ 	  chmod a-x $(libsubdir)/libb/libm020/libgcc.a; \
+ 	else true; fi
+ 
+ # PhB:
+ # toplev.o target need to define additional flags to handle stack
+ # allocation in real main. As for now we hack building of toplev.o
+ # defining MAYBE_USE_COLLECT2 flag, which is only used for toplev.o.
+ # Then we define EXTRA_OBJS to amigasup.o.
+ 
+ MAYBE_USE_COLLECT2= -Dmain=stkmain -Dexit=stkexit
+ EXTRA_OBJS = amigasup.o
+ 
+ # The default gcc (xgcc) is built without -DAMIGADOS_FORK_GCC. This gcc (xgccv)
+ # is built with AMIGADOS_FORK_GCC defined, so that it can use '-pipe'.  We
+ # don't want to define EXTRA_PASSES to xgccv because that will cause xgccv
+ # to be installed in $(libsubdir), so instead we use the default GCC_PASSES
+ # and add xgccv to it.
+ 
+ GCC_PASSES = xgcc xgccv cc1 cpp $(EXTRA_PASSES)
+ 
+ xgccv: xgccv.o version.o $(LIBDEPS)
+ 	$(CC) $(ALL_CFLAGS) $(LDFLAGS) -o xgccv xgccv.o version.o $(LIBS)
+ 
+ xgccv.o: gcc.c $(CONFIG_H) config.status
+ 	$(CC) $(ALL_CFLAGS) $(ALL_CPPFLAGS) $(INCLUDES) \
+   -DSTANDARD_STARTFILE_PREFIX=\"$(libdir)/\" \
+   -DSTANDARD_EXEC_PREFIX=\"$(libdir)/gcc-lib/\" \
+   -DDEFAULT_TARGET_VERSION=\"$(version)\" \
+   -DDEFAULT_TARGET_MACHINE=\"$(target)\" \
+   -DTOOLDIR_BASE_PREFIX=\"$(exec_prefix)/\" \
+   -DAMIGADOS_FORK_GCC \
+   -c `echo $(srcdir)/gcc.c | sed 's,^\./,,'` -o xgccv.o
+ 
+ install-gccv: xgccv
+ 	rm -f $(bindir)/gccv
+ 	$(INSTALL_PROGRAM) xgccv $(bindir)/gccv
+ 
+ # When making one of the stage<N> dirs, we need to make subdirs for
+ # additional libraries, and copy them there. base-relative libraries
+ # and accelerated libraries are preserved through stages.
+ 
+ EXTRA_STAGE1_TARGETS = stage1-libamiga
+ EXTRA_STAGE2_TARGETS = stage2-libamiga
+ EXTRA_STAGE3_TARGETS = stage3-libamiga
+ EXTRA_STAGE4_TARGETW = stage4-libamiga
+ 
+ stage1-libamiga:
+ 	-if [ -d stage1 ] ; then true ; else mkdir stage1 ; fi
+ 	-if [ -d stage1/libb ] ; then true ; else mkdir stage1/libb ; fi
+ 	-if [ -d stage1/libb/libm020 ] ; then true ; else mkdir stage1/libb/libm020 ; fi
+ 	-if [ -d stage1/libm020 ] ; then true ; else mkdir stage1/libm020 ; fi
+ 	-cp libb/libgcc.a stage1/libb/libgcc.a
+ 	-cp libb/libm020/libgcc.a stage1/libb/libm020/libgcc.a
+ 	-cp libm020/libgcc.a stage1/libm020/libgcc.a
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage1/libb/libgcc.i; else true; fi
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage1/libb/libm020/libgcc.a; else true; fi
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage1/libm020/libgcc.a; else true; fi
+ 
+ stage2-libamiga:
+ 	-if [ -d stage2 ] ; then true ; else mkdir stage2 ; fi
+ 	-if [ -d stage2/libb ] ; then true ; else mkdir stage2/libb ; fi
+ 	-if [ -d stage2/libb/libm020 ] ; then true ; else mkdir stage2/libb/libm020 ; fi
+ 	-if [ -d stage2/libm020 ] ; then true ; else mkdir stage2/libm020 ; fi
+ 	-cp libb/libgcc.a stage2/libb/libgcc.a
+ 	-cp libb/libm020/libgcc.a stage2/libb/libm020/libgcc.a
+ 	-cp libm020/libgcc.a stage2/libm020/libgcc.a
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage2/libb/libgcc.a; else true; fi
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage2/libb/libm020/libgcc.a; else true; fi
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage2/libm020/libgcc.a; else true; fi
+ 
+ stage3-libamiga:
+ 	-if [ -d stage3 ] ; then true ; else mkdir stage3 ; fi
+ 	-if [ -d stage3/libb ] ; then true ; else mkdir stage3/libb ; fi
+ 	-if [ -d stage3/libb/libm020 ] ; then true ; else mkdir stage3/libb/libm020 ; fi
+ 	-if [ -d stage3/libm020 ] ; then true ; else mkdir stage3/libm020 ; fi
+ 	-cp libb/libgcc.a stage3/libb/libgcc.a
+ 	-cp libb/libm020/libgcc.a stage3/libb/libm020/libgcc.a
+ 	-cp libm020/libgcc.a stage3/libm020/libgcc.a
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage3/libb/libgcc.a; else true; fi
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage3/libb/libm020/libgcc.a; else true; fi
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage3/libm020/libgcc.a; else true; fi
+ 
+ stage4-libamiga:
+ 	-if [ -d stage4 ] ; then true ; else mkdir stage4 ; fi
+ 	-if [ -d stage4/libb ] ; then true ; else mkdir stage4/libb ; fi
+ 	-if [ -d stage4/libb/libm020 ] ; then true ; else mkdir stage4/libb/libm020 ; fi
+ 	-if [ -d stage4/libm020 ] ; then true ; else mkdir stage4/libm020 ; fi
+ 	-cp libb/libgcc.a stage4/libb/libgcc.a
+ 	-cp libb/libm020/libgcc.a stage4/libb/libm020/libgcc.a
+ 	-cp libm020/libgcc.a stage4/libm020/libgcc.a
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage4/libb/libgcc.a; else true; fi
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage4/libb/libm020/libgcc.a; else true; fi
+ 	-if $(RANLIB_TEST) ; then $(RANLIB) stage4/libm020/libgcc.a; else true; fi
diff -2rcN /usr/goinfre/gcc-2.7.0/config/m68k/x-amigados gcc-2.7.0-amiga/config/m68k/x-amigados
*** /usr/goinfre/gcc-2.7.0/config/m68k/x-amigados
--- gcc-2.7.0-amiga/config/m68k/x-amigados	Fri Jun 23 11:52:21 1995
***************
*** 0 ****
--- 1,52 ----
+ # Note: It doesn't do any good to try to define prefix or local_prefix
+ # in the host overrides because configure will just change them back.
+ # You either have to give an appropriate option to configure or live with
+ # an Amiga specific patch to configure.  See the note in configure.  -fnf
+ 
+ # Building under amigados almost certainly requires an already working gcc.
+ # Use gccv, which is a gcc compiled with AMIGADOS_FORK_GCC so "-pipe" will
+ # work and get exercised.  To bootstrap with the regular gcc just do
+ # "make CC=gcc".  To bootstrap without "-pipe" do "make PIPE=".
+ 
+ CC = gccv $(PIPE)
+ 
+ # Disable -pipe for now since I had problems bootstrapping gcc 2.5.5 with
+ # it. (fnf)
+ #PIPE = -pipe
+ 
+ # Allow the user to override the default host optimization with gcc, or if the
+ # host compiler is not gcc and doesn't understand -O<N>.
+ 
+ X_OPTIMIZE = -O2
+ 
+ # The standard additional host flags for the compiler.
+ 
+ X_CFLAGS = $(X_OPTIMIZE)
+ 
+ # Man pages get a wierd suffix...
+ 
+ manext = .0
+ 
+ # We really shouldn't specify CFLAGS from here, but there's no other way
+ # to get rid of the `-g' indoctrinated by Makefile.in.  Note this becomes
+ # part of both the host compilation CFLAGS and the target compilation
+ # CFLAGS.
+ 
+ CFLAGS =
+ 
+ # Ranlib does exist, but may not be in a path where the default RANLIB_TEST
+ # expects it, so just force it to true.
+ 
+ RANLIB_TEST = true
+ 
+ # Until we can make sure no cross-device hardlinks are tried, and until
+ # symlinks can be made in canonical amigados format (dev:path/file), just
+ # use copy with timestamp preservation.  This only wastes some disk space
+ # and means you have to reconfigure if you change any of the files that
+ # would normally be linked to.  -fnf
+ 
+ HARDLINK = cp -p
+ SYMLINK = cp -p
+ 
+ # Build supplimentary Amiga host support file.
+ amigasup.o: amigasup.c
diff -2rcN /usr/goinfre/gcc-2.7.0/config/m68k/xm-amigados.h gcc-2.7.0-amiga/config/m68k/xm-amigados.h
*** /usr/goinfre/gcc-2.7.0/config/m68k/xm-amigados.h
--- gcc-2.7.0-amiga/config/m68k/xm-amigados.h	Fri Jun 23 11:52:21 1995
***************
*** 0 ****
--- 1,255 ----
+ /* Configuration for GNU C-compiler for Commodore Amiga, running AmigaDOS.
+    Copyright (C) 1992 Free Software Foundation, Inc.
+    Contributed by Markus M. Wild (wild@amiga.physik.unizh.ch).
+ 
+ This file is part of GNU CC.
+ 
+ GNU CC is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ GNU CC is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with GNU CC; see the file COPYING.  If not, write to
+ the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ /* first include the generic header, then modify some parts.. */
+ 
+ #include "m68k/xm-m68k.h"
+ 
+ /* On the Amiga, there are two pathname separators, '/' (DIR_SEPARATOR)
+    and ':' (VOL_SEPARATOR).  DIR_SEPARATOR defaults to the correct
+    character, so we don't have to explicitly set it. */
+ 
+ #define VOL_SEPARATOR ':'
+ 
+ /* Amiga specific headers, such as from the Native Developer Update kits,
+    go in SYSTEM_INCLUDE_DIR.  STANDARD_INCLUDE_DIR is the equivalent of
+    Unix "/usr/include".  All other include paths are set in Makefile. */
+ 
+ #define SYSTEM_INCLUDE_DIR	"/gnu/os-include"
+ #define STANDARD_INCLUDE_DIR	"/gnu/include"
+ 
+ /* Fork one piped subcommand.  SEARCH_FLAG is the system call to use
+    (either execv or execvp).  ARGV is the arg vector to use.
+    NOT_LAST is nonzero if this is not the last subcommand
+    (i.e. its output should be piped to the next one.)  */
+ 
+ #ifndef AMIGADOS_FORK_GCC
+ 
+ /* This version uses a more or less amigados-conformant way of running a
+    program (in the context of the parent). If you want to use -pipe however,
+    you'll have to use the vfork() version afterwards.
+    Phil.B: 29-May-94 quick hack (number 20 added to length) because xgcc
+    doesn't work.
+  */
+ 
+ #define PEXECUTE(SEARCH_FLAG,PROGRAM,ARGV,NOT_LAST) \
+ ({char *_argline;						\
+   int _arglinelength, _i;					\
+ 								\
+   for (_i = 1, _arglinelength=0; ARGV[_i]; ++_i)		\
+     _arglinelength += strlen(ARGV[_i]) + 1;			\
+ 								\
+   _arglinelength += strlen(PROGRAM) + 20 + 1;			\
+ 								\
+   if (!(_argline = (char *)alloca(_arglinelength))) 		\
+     pfatal_with_name ("alloca");				\
+ 								\
+   strcpy(_argline, PROGRAM);					\
+   for (_i = 1; ARGV[_i]; ++_i) 					\
+     {								\
+       strcat(_argline, " ");					\
+       strcat(_argline, ARGV[_i]);				\
+     }								\
+ 								\
+   ssystem(_argline); })						\
+ 
+ #define PEXECUTE_RESULT(STATUS, COMMAND) \
+   ({ STATUS = COMMAND.pid; })
+ 
+ #else
+ 
+ /* the vfork() version. This one has the drawback, that gcc is not 
+    interruptible when started from make, since ixemul.library doesn't yet
+    propagate ^C to subprocesses. */
+ 
+ #define PEXECUTE(SEARCH_FLAG,PROGRAM,ARGV,NOT_LAST) \
+ ({int (*_func)() = (SEARCH_FLAG ? execv : execvp);			\
+   int _pid;								\
+   int _pdes[2];								\
+   int _input_desc = last_pipe_input;					\
+   int _output_desc = STDOUT_FILE_NO;					\
+   int _retries, _sleep_interval, _result;				\
+ 									\
+   /* If this isn't the last process, make a pipe for its output,	\
+      and record it as waiting to be the input to the next process.  */	\
+ 									\
+   if (NOT_LAST)								\
+     {									\
+       if (pipe (_pdes) < 0)						\
+ 	pfatal_with_name ("pipe");					\
+       _output_desc = _pdes[WRITE_PORT];					\
+       last_pipe_input = _pdes[READ_PORT];				\
+     }									\
+   else									\
+     last_pipe_input = STDIN_FILE_NO;					\
+ 									\
+   /* Fork a subprocess; wait and retry if it fails.  */			\
+   _sleep_interval = 1;							\
+   for (_retries = 0; _retries < 4; _retries++)				\
+     {									\
+       _pid = vfork ();							\
+       if (_pid >= 0)							\
+ 	break;								\
+       sleep (_sleep_interval);						\
+       _sleep_interval *= 2;						\
+     }									\
+ 									\
+   switch (_pid)								\
+     {									\
+     case -1:								\
+       pfatal_with_name ("vfork");					\
+       /* NOTREACHED */							\
+       _result = 0;							\
+       break;								\
+ 									\
+     case 0: /* child */							\
+       /* Move the input and output pipes into place, if nec.  */	\
+       if (_input_desc != STDIN_FILE_NO)					\
+ 	{								\
+ 	  close (STDIN_FILE_NO);					\
+ 	  dup (_input_desc);						\
+ 	  close (_input_desc);						\
+ 	}								\
+       if (_output_desc != STDOUT_FILE_NO)				\
+ 	{								\
+ 	  close (STDOUT_FILE_NO);					\
+ 	  dup (_output_desc);						\
+ 	  close (_output_desc);						\
+ 	}								\
+ 									\
+       /* Close the parent's descs that aren't wanted here.  */		\
+       if (last_pipe_input != STDIN_FILE_NO)				\
+ 	close (last_pipe_input);					\
+ 									\
+       /* Exec the program.  */						\
+       (*_func) (PROGRAM, ARGV);						\
+       perror_exec (PROGRAM);						\
+       exit (-1);							\
+       /* NOTREACHED */							\
+       _result = 0;							\
+       break;								\
+ 									\
+     default:								\
+       /* In the parent, after forking.					\
+ 	 Close the descriptors that we made for this child.  */		\
+       if (_input_desc != STDIN_FILE_NO)					\
+ 	close (_input_desc);						\
+       if (_output_desc != STDOUT_FILE_NO)				\
+ 	close (_output_desc);						\
+ 									\
+       /* Return child's process number.  */				\
+       _result = _pid;							\
+       break;								\
+     } 									\
+ _result; })								\
+ 
+ #define PEXECUTE_RESULT(STATUS, COMMAND) \
+   ({ wait (& STATUS); })
+ 
+ #endif /* AMIGADOS_FORK_GCC */
+ 
+ /* the following macros are stolen more or less from xm-vms.h ... */
+ 
+ /* This macro is used to help compare filenames in cp-lex.c.
+ 
+    We also need to make sure that the names are all lower case, because
+    we must be able to compare filenames to determine if a file implements
+    a class.  */
+ 
+ #define FILE_NAME_NONDIRECTORY(C)				\
+ ({								\
+    extern char *rindex();					\
+    char * pnt_ = (C), * pnt1_;					\
+    pnt1_ = pnt_ - 1;						\
+    while (*++pnt1_)						\
+      if ((*pnt1_ >= 'A' && *pnt1_ <= 'Z')) *pnt1_ |= 0x20;	\
+    pnt1_ = rindex (pnt_, '/'); 					\
+    pnt1_ = (pnt1_ == 0 ? rindex (pnt_, ':') : pnt1_);		\
+    (pnt1_ == 0 ? pnt_ : pnt1_ + 1);				\
+  })
+ 
+ /* Macro to generate the name of the cross reference file.  The standard
+    one does not work, since it was written assuming that the conventions
+    of a unix style filesystem will work on the host system.
+  
+    Contrary to VMS, I'm using the original unix filename, there's no reason
+    not to use this under AmigaDOS. */
+ 
+ #define XREF_FILE_NAME(BUFF, NAME)	\
+   s = FILE_NAME_NONDIRECTORY (NAME);			\
+   if (s == NAME) sprintf(BUFF, ".%s.gxref", NAME);	\
+   else {						\
+     unsigned char ch = *s; /* could be Latin1 char.. */	\
+     /* temporary: cut the filename from the directory */\
+     *s = 0;						\
+     sprintf (BUFF, "%s.%c%s.gxref", NAME, ch, s+1);	\
+     /* and restore the filename */			\
+     *s = ch;						\
+   }							\
+ 
+ /* Macro that is used in cp-xref.c to determine whether a file name is
+    absolute or not.
+ 
+    This checks for both, '/' as first character, since we're running under
+    ixemul.library which provides for this unix'ism, and for the usual 
+    logical-terminator, ':', somewhere in the filename. */
+ 
+ #define FILE_NAME_ABSOLUTE_P(NAME) (NAME[0] == '/' || index(NAME, ':'))
+ 
+ /* the colon conflicts with the name space of logicals */
+ 
+ #define PATH_SEPARATOR ','
+ 
+ /* AmigaDOS handles rename(2) *much* better than any link(2)/unlink(2)
+    hacks. It's actually the inverse case as on Unix. rename(2) was always
+    there, link(2) is new with OS 2.0 */
+ 
+ #define HAVE_rename 1
+ 
+ /* Phil.B 17-Apr-95 Added stack checking code submitted by Kriton Kyrimis
+    (kyrimis@theseas.ntua.gr) on 10-Feb-95, modified for inclusion into gcc
+ 
+    What stackcheck does is to add the following code at the beginning of
+    each function:
+ 	cmpl __StackBottom,sp
+ 	bccs .+8
+ 	jmp __StackOverflow
+ 
+    _StackBottom and _StackOverflow() are defined in stackchecksetup.c.
+    _StackBottom is set to the bottom of the stack plus some leeway for
+    subroutine arguments (128 bytes).  _StackOverflow() sets the stack
+    pointer to a sane value, prints an error message and exits.
+ 
+    Even with stack checking, you cannot be completely safe, as overflows
+    are detected on function entry, rather than during function execution.
+    E.g.,
+ 	crash(){
+ 	  char scribble[100000];
+ 	  int i;
+ 	  for (i=0; i<100000; i++) scribble[i]=0;
+ 	  check(scribble);
+ 	}
+ 	check(char *x){}
+    In the above example, stack overflow and its side-effects will occur in
+    crash(), but it will be detected in check(), when it is too late. (The
+    same thing happens with SAS/C's stack checking, BTW.)
+ */
+ 
+ /* #defined AMIGA_STACK_CHECKING */
diff -2rcN /usr/goinfre/gcc-2.7.0/cp/Make-lang.in gcc-2.7.0-amiga/cp/Make-lang.in
*** /usr/goinfre/gcc-2.7.0/cp/Make-lang.in	Fri Jun 16 20:09:57 1995
--- gcc-2.7.0-amiga/cp/Make-lang.in	Fri Jun 23 11:52:22 1995
***************
*** 74,78 ****
  cxxmain.o: cplus-dem.c demangle.h
  	rm -f cxxmain.c
! 	ln -s $(srcdir)/cplus-dem.c cxxmain.c > /dev/null 2>&1 \
  	 || cp $(srcdir)/cplus-dem.c cxxmain.c
  	$(CC) -c -DMAIN $(ALL_CFLAGS) $(ALL_CPPFLAGS) $(INCLUDES) \
--- 74,78 ----
  cxxmain.o: cplus-dem.c demangle.h
  	rm -f cxxmain.c
! 	$(SYMLINK) $(srcdir)/cplus-dem.c cxxmain.c > /dev/null 2>&1 \
  	 || cp $(srcdir)/cplus-dem.c cxxmain.c
  	$(CC) -c -DMAIN $(ALL_CFLAGS) $(ALL_CPPFLAGS) $(INCLUDES) \
***************
*** 122,126 ****
  	    chmod a+x $(bindir)/$(GXX_CROSS_NAME)$(exeext); \
  	    rm -f $(bindir)/$(CXX_CROSS_NAME)$(exeext); \
! 	    ln $(bindir)/$(GXX_CROSS_NAME)$(exeext) $(bindir)/$(CXX_CROSS_NAME)$(exeext) \
  	      > /dev/null 2>&1 \
  	      || cp $(bindir)/$(GXX_CROSS_NAME)$(exeext) $(bindir)/$(CXX_CROSS_NAME)$(exeext) ; \
--- 122,126 ----
  	    chmod a+x $(bindir)/$(GXX_CROSS_NAME)$(exeext); \
  	    rm -f $(bindir)/$(CXX_CROSS_NAME)$(exeext); \
! 	    $(HARDLINK) $(bindir)/$(GXX_CROSS_NAME)$(exeext) $(bindir)/$(CXX_CROSS_NAME)$(exeext) \
  	      > /dev/null 2>&1 \
  	      || cp $(bindir)/$(GXX_CROSS_NAME)$(exeext) $(bindir)/$(CXX_CROSS_NAME)$(exeext) ; \
***************
*** 130,134 ****
  	    chmod a+x $(bindir)/$(GXX_INSTALL_NAME)$(exeext); \
  	    rm -f $(bindir)/$(CXX_INSTALL_NAME)$(exeext); \
! 	    ln $(bindir)/$(GXX_INSTALL_NAME)$(exeext) $(bindir)/$(CXX_INSTALL_NAME)$(exeext) \
  	      > /dev/null 2>&1 \
  	      || cp $(bindir)/$(GXX_INSTALL_NAME)$(exeext) $(bindir)/$(CXX_INSTALL_NAME)$(exeext) ; \
--- 130,134 ----
  	    chmod a+x $(bindir)/$(GXX_INSTALL_NAME)$(exeext); \
  	    rm -f $(bindir)/$(CXX_INSTALL_NAME)$(exeext); \
! 	    $(HARDLINK) $(bindir)/$(GXX_INSTALL_NAME)$(exeext) $(bindir)/$(CXX_INSTALL_NAME)$(exeext) \
  	      > /dev/null 2>&1 \
  	      || cp $(bindir)/$(GXX_INSTALL_NAME)$(exeext) $(bindir)/$(CXX_INSTALL_NAME)$(exeext) ; \
***************
*** 194,197 ****
  	cd cp; \
  	for file in *[0-9a-zA-Z+]; do \
! 	  ln $$file ../tmp/cp >/dev/null 2>&1 || cp $$file ../tmp/cp; \
  	done
--- 194,197 ----
  	cd cp; \
  	for file in *[0-9a-zA-Z+]; do \
! 	  $(HARDLINK) $$file ../tmp/cp >/dev/null 2>&1 || cp $$file ../tmp/cp; \
  	done
diff -2rcN /usr/goinfre/gcc-2.7.0/cp/g++.c gcc-2.7.0-amiga/cp/g++.c
*** /usr/goinfre/gcc-2.7.0/cp/g++.c	Thu Jun 15 13:23:15 1995
--- gcc-2.7.0-amiga/cp/g++.c	Fri Jun 23 11:52:23 1995
***************
*** 242,246 ****
--- 242,250 ----
  
    if (errno < sys_nerr)
+ #ifdef HAVE_STRERROR
+     s = concat ("%s: ", strerror(errno), "");
+ #else
      s = concat ("%s: ", sys_errlist[errno], "");
+ #endif
    else
      s = "cannot open %s";
